"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.write = exports.match = undefined;

var _fs = require("fs");

var _fastDeepEqual = require("fast-deep-equal");

var _fastDeepEqual2 = _interopRequireDefault(_fastDeepEqual);

var _jestDiff = require("jest-diff");

var _jestDiff2 = _interopRequireDefault(_jestDiff);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const readJsonSync = file => {
  try {
    const text = (0, _fs.readFileSync)(file, "utf-8");
    return JSON.parse(text);
  } catch (error) {
    return {};
  }
};

const writeJsonSync = (file, data) => (0, _fs.writeFileSync)(file, JSON.stringify(data, null, 2) + "\n");

const match = exports.match = ({ snapshotPath, name, data }) => {
  const snapshot = readJsonSync(snapshotPath);
  const prevData = snapshot[name] || {};
  if (!(0, _fastDeepEqual2.default)(prevData, data)) {
    console.error((0, _jestDiff2.default)(prevData, data));
    throw Error("size snapshot is not matched");
  }
};

const write = exports.write = ({ snapshotPath, name, data }) => {
  const snapshot = readJsonSync(snapshotPath);
  snapshot[name] = data;
  writeJsonSync(snapshotPath, snapshot);
};