"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.treeshakeWithRollup = undefined;

var _rollup = require("rollup");

var _uglifyEs = require("uglify-es");

var _rollupPluginReplace = require("rollup-plugin-replace");

var _rollupPluginReplace2 = _interopRequireDefault(_rollupPluginReplace);

var _utils = require("./utils.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const inputName = "__size_snapshot_input__.js";
const bundleName = "__size_snapshot_bundle__.js";

const isReservedId = id => id.includes(inputName) || id.includes(bundleName);

const resolvePlugin = ({ code }) => ({
  resolveId(importee) {
    if (isReservedId(importee)) {
      return importee;
    }
    return null;
  },

  load(id) {
    if (id.includes(inputName)) {
      return `import {} from "/${bundleName}";`;
    }
    if (id.includes(bundleName)) {
      return code;
    }
    return null;
  }
});

const treeshakeWithRollup = exports.treeshakeWithRollup = code => {
  const config = {
    input: `/${inputName}`,
    onwarn() {},
    external: _utils.isExternal,
    plugins: [resolvePlugin({ code }), (0, _rollupPluginReplace2.default)({ "process.env.NODE_ENV": JSON.stringify("production") })]
  };

  return (0, _rollup.rollup)(config).then(bundle => bundle.generate({ format: "es" })).then(result => (0, _uglifyEs.minify)(result.code, { toplevel: true })).then(result => result.code);
};