"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.treeshakeWithWebpack = undefined;

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

var _memoryFs = require("memory-fs");

var _memoryFs2 = _interopRequireDefault(_memoryFs);

var _utils = require("./utils.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const inputName = "__size_snapshot_input__.js";

const bundleName = "__size_snapshot_bundle__.js";
const outputName = "__size_snapshot_output__.js";

const treeshakeWithWebpack = exports.treeshakeWithWebpack = code => {
  const inputFS = new _memoryFs2.default();
  const outputFS = new _memoryFs2.default();

  const compiler = (0, _webpack2.default)({
    entry: `/${inputName}`,
    output: {
      path: "/",
      filename: outputName
    },
    mode: "production",
    externals: [(context, request, callback) => {
      if ((0, _utils.isExternal)(request)) {
        callback(null, "commonjs " + request);
      } else {
        callback();
      }
    }]
  });

  inputFS.writeFileSync(`/${inputName}`, `import {} from '/${bundleName}'`);
  inputFS.writeFileSync(`/${bundleName}`, code);

  compiler.inputFileSystem = inputFS;
  compiler.outputFileSystem = outputFS;

  return new Promise((resolve, reject) => {
    compiler.run((err, stats) => {
      if (err) {
        reject(err);
      } else {
        resolve(outputFS.readFileSync(`/${outputName}`, "utf8"));
      }
    });
  });
};